
//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature_Area.h"


/**
 * @brief Konstruktor
 */
Feature_Area::Feature_Area()
{
	Feature();
	ID = 3;
	NAME = "Area";
	DIM = 1;
}



/**
 * @brief Destruktor
 */
Feature_Area::~Feature_Area() 
{
	//Tom destruktor
}



/**
 * @brief Beregner arealet til en region.
 * 
 * @param r Peker til aktuell region.
 *
 * @return Peker til en vektor som holder beregnet areal av regionen.
 */
float * Feature_Area::calculate(Region *r)
{
	float *v = new float[1];
	v[0] = (float) r->getArea();
	return v;
}