
//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature_BoundingBox.h"


/**
 * @brief Konstruktor
 */
Feature_BoundingBox::Feature_BoundingBox()
{
	Feature();
	ID = 5;
	NAME = "Bounding box";
	DIM = 4;
}



/**
 * @brief Destruktor
 */
Feature_BoundingBox::~Feature_BoundingBox()
{
	//Tom destruktor
}



/**
 * @brief Beregner omsluttende rektangel til en region.
 * 
 * @param r Peker til aktuell region.
 *
 * @return Peker til en vektor som holder beregnet omsluttende rektangel av regionen.
 */
float * Feature_BoundingBox::calculate(Region *r)
{
	int *bb = r->getBoundingBox();
	float *v = new float[4];
	for (int i=0; i<4; i++)
	{
		v[i] = (float) bb[i];
	}
	return v;
}