
//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature_Mean.h"


/**
 * @brief Konstruktor
 */
Feature_Mean::Feature_Mean()
{
	Feature();
	ID = 9;
	NAME = "Mean color";
	DIM = 3;
}



/**
 * @brief Destruktor
 */
Feature_Mean::~Feature_Mean()
{
	//Tom destruktor
}



/**
 * @brief Beregner gjennomsnittlig farge til en region.
 * 
 * @param r Peker til aktuell region.
 *
 * @return Peker til en vektor som holder beregnet snittfarge av regionen.
 */
float * Feature_Mean::calculate(Region *r)
{
	float *v = new float[3];

	v[0] = (float) r->getR();
	v[1] = (float) r->getG();
	v[2] = (float) r->getB();

	return v;
}