

/*
    QuickSort er en klasse som sorterer elementene i matrisen.
    Koden er tilpasset en smule fra fundamentet som er skrevet
    av Cay Horstmann (tilgjengelig p
    http://www.augustana.ca/~mohrj/courses/2004.winter/csc310/
    source/QuickSort.java.html)

	Forfatter: 	Cay Horstmann (fundament)
				Per Gunnar Brdsen (lett tilpasning)
*/

 /*
   Kommentar fra Cay Horstmann:
   This class implements a version of the quicksort algorithm using a partition
   algorithm that does not rely on the first element of the array being vacant,
   nor does it guarantee that the chosen pivot value is at the split point of
   the partition.
 */

 import java.util.ArrayList;

 public class QuickSort
 {

	private ArrayList a;

    public void QuickSort() {}

	public ArrayList sort(ArrayList list)
	{
     	a = list;
        sort(0, a.size() - 1);
        return a;
	}

    public void sort(int low, int high)
    {
       if (low >= high) return;
       int p = partition(low, high);
       sort(low, p);
       sort(p + 1, high);
    }

    private int partition(int low, int high)
    {
       ElementPar pivot = (ElementPar) a.get(low);
       int i = low - 1;
       int j = high + 1;
       while (i < j)
       {
          i++; while ( ((ElementPar) a.get(i)).v < pivot.v) i++;
          j--; while ( ((ElementPar) a.get(j)).v > pivot.v) j--;
          if (i < j) swap(i, j);
       }
       return j;
    }

    /*
      Kommentar fra Cay Horstmann:
      Swaps two entries of the array.
      @param i the first position to swap
      @param j the second position to swap
    */
    private void swap(int i, int j)
    {
       ElementPar temp_i = (ElementPar) a.get(i);
       ElementPar temp_j = (ElementPar) a.get(j);
       a.remove(i);
       a.add(i, temp_j);
       a.remove(j);
       a.add(j, temp_i);
    }

 }

