
//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature_Centroid.h"


/**
 * @brief Konstruktor
 */
Feature_Centroid::Feature_Centroid()
{
	Feature();
	ID = 4;
	NAME = "Centroid";
	DIM = 2;
}



/**
 * @brief Destruktor
 */
Feature_Centroid::~Feature_Centroid() 
{
	//Tom destruktor
}



/**
 * @brief Beregner massesenteret til en region.
 * 
 * @param r Peker til aktuell region.
 *
 * @return Peker til en vektor som holder beregnet massesenter av regionen.
 */
float * Feature_Centroid::calculate(Region *r)
{
	float *v = new float[2];
	v[0] = (float) r->getCentroid().x;
	v[1] = (float) r->getCentroid().y;
	return v;
}