
//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature_Circularity.h"

/**
 * @brief Konstruktor
 */
Feature_Circularity::Feature_Circularity()
{
	Feature();
	ID = 6;
	NAME = "Circularity";
	DIM = 1;
}



/**
 * @brief Destruktor
 */
Feature_Circularity::~Feature_Circularity()
{
	//Tom destruktor
}



/**
 * @brief Beregner rundhet/sirkularitet til en region.
 * 
 * @param r Peker til aktuell region.
 *
 * @return Peker til en vektor som holder beregnet rundhet/sirkularitet av regionen.
 */
float * Feature_Circularity::calculate(Region *r)
{
	float *v = new float[1];
	v[0] = valueHandler( (float) ( r->getBorder().size() * r->getBorder().size() / r->getArea() ) );
	return v;
}