
//Refereanser til eksternt grensesnitt/kode som anvendes i denne filen
#include "Feature_Perimeter.h"


/**
 * @brief Konstruktor
 */
Feature_Perimeter::Feature_Perimeter()
{
	Feature();
	ID = 2;
	NAME = "Perimeter";
	DIM = 1;
}



/**
 * @brief Destruktor
 */
Feature_Perimeter::~Feature_Perimeter() 
{
	//Tom destruktor
}



/**
 * @brief Beregner omkretsen til en region.
 * 
 * @param r Peker til aktuell region.
 *
 * @return Peker til en vektor som holder beregnet omkrets av regionen.
 */
float * Feature_Perimeter::calculate(Region *r)
{
	float *v = new float[1];
	v[0] = (float) r->getBorder().size();
	return v;
}