#pragma once

/**
 * @class Pixel
 * @brief Klasse som representerer piksler i et bilde.
 *
 * @version 1.0
 * @author Per Gunnar Brdsen
 */
class Pixel
{
public:

	///Variabel som holder pikselens x-posisjon i bildet.
	unsigned int x;

	///Variabel som holder pikselens y-posisjon i bildet.
	unsigned int y;

	///Variabel som holder pikselens rde verdi.
	int r;

	///Variabel som holder pikselens grnne verdi.
	int g;

	///Variabel som holder pikselens bl verdi.
	int b;

	/**
	 * @brief Konstruktor
	 */
	Pixel();


	/**
	 * @brief Konstruktor
	 *
	 * @param _x Pikselens x-posisjon i bildet.
	 * @param _y Pikselens y-posisjon i bildet.
	 * @param _r Pikselens rde verdi.
	 * @param _g Pikselens grnne verdi.
	 * @param _b Pikselens bl verdi.
	 */
	Pixel(unsigned int _x, unsigned int _y, int _r, int _g, int _b);
	

	/**
	 * @brief Destruktor
	 */
	~Pixel();
};
